import { SQLiteDatabase } from "expo-sqlite";
import { Relation, Model, ModelValue, QueryParams, WhereCondition, Config, PrimaryKeyValue } from "@canvas-js/modeldb";
export declare class ModelAPI {
    #private;
    readonly db: SQLiteDatabase;
    readonly config: Config;
    readonly model: Model;
    columnNames: `"${string}"`[];
    constructor(db: SQLiteDatabase, config: Config, model: Model);
    get(key: PrimaryKeyValue): ModelValue | null;
    getMany(keys: PrimaryKeyValue[]): (ModelValue | null)[];
    set(value: ModelValue): void;
    delete(key: PrimaryKeyValue): void;
    clear(): void;
    count(where?: WhereCondition): number;
    query(query: QueryParams): ModelValue[];
    iterate(query: QueryParams): Iterable<ModelValue>;
    private parseRecord;
    private parseQuery;
    private getSelectExpression;
    private getWhereExpression;
}
export declare class RelationAPI {
    #private;
    readonly db: SQLiteDatabase;
    readonly relation: Relation;
    readonly table: string;
    readonly sourceIndex: string;
    readonly targetIndex: string;
    constructor(db: SQLiteDatabase, relation: Relation);
    get(source: PrimaryKeyValue): PrimaryKeyValue[];
    add(source: PrimaryKeyValue, targets: PrimaryKeyValue[]): void;
    delete(source: PrimaryKeyValue): void;
}
