import { PrimaryKeyValue, type Model, type ModelValue, type PrimitiveProperty, type PrimitiveValue, type ReferenceProperty } from "@canvas-js/modeldb";
import { SQLiteBindValue } from "expo-sqlite";
export type SqlitePrimitiveValue = string | number | Uint8Array | null;
export type RecordValue = Record<string, SqlitePrimitiveValue>;
export type RecordParams = Record<`p${string}`, SQLiteBindValue>;
export declare function encodeQueryParams(params: Record<string, PrimitiveValue>): Record<string, SqlitePrimitiveValue>;
export declare function encodeRecordParams(model: Model, value: ModelValue, params: Record<string, `p${string}`>): Record<`p${string}`, SqlitePrimitiveValue>;
export declare function decodeRecord(model: Model, record: Record<string, SqlitePrimitiveValue>): ModelValue;
export declare function decodePrimitiveValue(modelName: string, property: PrimitiveProperty, value: SqlitePrimitiveValue): PrimitiveValue;
export declare function decodeReferenceValue(modelName: string, property: ReferenceProperty, value: SqlitePrimitiveValue): PrimaryKeyValue | null;
